#include <stdio.h>
#include <string.h>

#define NMAX 511

int np[NMAX];
char A[NMAX][NMAX];

void CountPrimes() {
	int i, j;
	np[0] = np[1] = 0;
	np[2] = 1;
	for (i = 3; i < NMAX; i++) {
		np[i] = np[i - 1];
		for (j = 2; j * j <= i; j++)
			if (i % j == 0)
				break;
		if (j * j > i)
			np[i]++;
	}
}

int L[NMAX][NMAX][4];

int main() {
	CountPrimes();

	//freopen("x.txt", "r", stdin);
	int T, R, C, i, j, k, ans = 0;
	scanf("%d", &T);
	
	while (T--) {
		scanf("%d %d", &R, &C);
		for (i = 1; i <= R; i++)
			scanf("%s", &(A[i][1]));

		memset(L, 0, sizeof(L));
		for (i = 1; i <= R; i++)
			for (j = 1; j <= C; j++)
				if (A[i][j] == '^')
					L[i][j][0] = 1 + L[i - 1][j][0];

		for (i = R; i >= 1; i--)
			for (j = 1; j <= C; j++)
				if (A[i][j] == '^')
					L[i][j][1] = 1 + L[i + 1][j][1];

		for (j = 1; j <= C; j++)
			for (i = 1; i <= R; i++)
				if (A[i][j] == '^')
					L[i][j][2] = 1 + L[i][j - 1][2];

		for (j = C; j >= 1; j--)
			for (i = 1; i <= R; i++)
				if (A[i][j] == '^')
					L[i][j][3] = 1 + L[i][j + 1][3];

		for (ans = 0, i = 1; i <= R; i++)
			for (j = 1; j <= C; j++)
				if (A[i][j] == '^') {
					k = L[i][j][0];
					if (L[i][j][1] < k)
						k = L[i][j][1];
					if (L[i][j][2] < k)
						k = L[i][j][2];
					if (L[i][j][3] < k)
						k = L[i][j][3];
					k--;
					ans += np[k];
				}
	
		printf("%d\n", ans);
	}
	
	return 0;
}
