#include <stdio.h>
#include <algorithm>

using namespace std;

#define MOD 1000000007
#define NMAX 131072

int v[NMAX << 1];

int query(int a) {
	int b = NMAX + a - 1, result = 0, rpoz = 0;
	while (b > 1) {
		if ((b & 1) == 1) {
			// b is the right son of its parent.
			result = max(result, v[b - 1]);
		}
		b = b >> 1;
	}
	return result;
}

void update(int a, int val) {
	int b = NMAX + a - 1;
	while (b >= 1) {
		v[b] = max(v[b], val);
		b = b >> 1;
	}
}

#define MMAX 1111111

int a[MMAX];

int main() {
	int N, K, i, x, y;
	long long ans = 1;

	scanf("%d %d", &N, &K);
	for (i = 1; i <= N; i++)
		scanf("%d", &a[i]);

	for (i = N; i >= 1; i--) {
		x = a[i];
		y = query(x);
		//fprintf(stderr, "i=%d x=%d y=%d\n", i, x, y);
		if (y > 0)
			ans = (ans * (long long) ((N - i + 1) - y + 1)) % MOD;
		update(x, N - i + 1);
	}
	
	printf("%lld\n", ans);
	
	return 0;
}
