#include <stdio.h>
#include <string.h>

#define NMAX 5010

char ispali[NMAX][NMAX], S[NMAX];
int pmin[NMAX];
int N, i, j, l;

int main() {
	int T;
	scanf("%d", &T);
	while (T--) {
		scanf("%d %s", &N, S + 1);
		
		memset(ispali, 0, sizeof(ispali));

		for (i = 1; i <= N; i++)
			ispali[i][i] = 1;
		for (i = 1; i < N; i++)
			if (S[i] == S[i + 1])
				ispali[i][i + 1] = 1;
		
		for (l = 3; l <= N; l++)
			for (i = 1; i <= N - l + 1; i++) {
				j = i + l - 1;
				if (S[i] == S[j] && ispali[i + 1][j - 1])
					ispali[i][j] = 1;
			}

		pmin[0] = 0;
		for (i = 1; i <= N; i++) {
			pmin[i] = i;
			for (j = i; j >= 1; j--)
				if (ispali[j][i] && pmin[j - 1] + 1 < pmin[i])
					pmin[i] = pmin[j - 1] + 1;
		}
		
		printf("%d\n", pmin[N]);
	}

	return 0;
}
