#include <stdio.h>
#include <string.h>

#define PMAX 501
#define SMAX 501

unsigned long long cnum[PMAX][SMAX], cnumsum[PMAX][SMAX];

unsigned long long RaiseToPow(unsigned long long x, unsigned long long y) {
	if (y == 0)
		return 1;
	if (y == 1)
		return x;
	unsigned long long res = RaiseToPow(x, y >> 1);
	res *= res;
	if (y & 1)
		res = res * x;
	return res;
}

int main() {
	int T, S, C, p, i;
	unsigned long long K, tmp, answer;

	//freopen("x.txt", "r", stdin);
	scanf("%d", &T);
	
	while (T--) {
		scanf("%d %d %llu", &C, &S, &K);
		if (S == 0) {
			printf("0\n");
			continue;
		}

		memset(cnum[0], 0, sizeof(cnum[0]));
		memset(cnumsum[0], 0, sizeof(cnumsum[0]));
		cnum[0][0] = 1;
		
		memset(cnum[1], 0, sizeof(cnum[1]));
		memset(cnumsum[1], 0, sizeof(cnumsum[1]));

		for (i = 0; i <= S && i < C; i++) {
			cnum[1][i] = 1;
			cnumsum[1][i] = cnum[1][i];
			if (i > 0)
				cnumsum[1][i] += cnumsum[1][i - 1];
		}
	
		for (i = C; i <= S; i++)
			cnumsum[1][i] = cnumsum[1][i - 1];
		
		for (p = 2; cnum[p - 1][S] < K; p++) {
			memset(cnum[p], 0, sizeof(cnum[p]));
			memset(cnumsum[p], 0, sizeof(cnumsum[p]));
			for (i = 0; i <= S; i++) {
				cnum[p][i] = cnumsum[p - 1][i];
				if (i >= C)
					cnum[p][i] -= cnumsum[p - 1][i - C];
				cnumsum[p][i] = cnum[p][i];
				if (i > 0)
					cnumsum[p][i] += cnumsum[p][i - 1];
				
				//fprintf(stderr, "  cnum[%d %d]=%llu\n", p, i, cnum[p][i]);
			}
		}
	
		for (answer = 0, p--; p >= 1; p--) {
			for (i = 0; i < C && i <= S; i++)
				if (cnum[p - 1][S - i] < K)
					K -= cnum[p - 1][S - i];
				else
					break;
			
			S -= i;
			//fprintf(stderr, "poz=%d: value=%d K=%llu S=%d\n", p - 1, i, K, S);
			answer += RaiseToPow(C, p - 1) * i;
		}
	
		//fprintf(stderr, "S=%d\n", S);
		printf("%llu\n", answer);
	}
	
	return 0;
}
