#include <stdio.h>
#include <string.h>

#define VMAX 100100
#define NMOVES 10
#define GMAX 100

int G[VMAX], vmove[NMOVES], nmoves;
char exists[GMAX];

void ComputeGrundy() {
	int i, j;
	
	nmoves = 6;
	for (i = 1; i <= 6; i++) {
		vmove[i] = 1;
		for (j = 1; j <= i; j++)
			vmove[i] *= i;
	}

	G[0] = 0;
	for (i = 1; i < VMAX; i++) {
		memset(exists, 0, sizeof(exists));
		for (j = 1; j <= nmoves; j++)
			if (i - vmove[j] >= 0)
				exists[G[i - vmove[j]]] = 1;
		for (G[i] = 0; exists[G[i]]; G[i]++);
	}
}

int main() {
	ComputeGrundy();
	
	int T, N, i, x, ans;
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &N);
		for (i = ans = 0; i < N; i++) {
			scanf("%d", &x);
			ans ^= G[x];
		}
		if (ans > 0)
			printf("Little Chef\n");
		else
			printf("Head Chef\n");
	}
}
