#include <stdio.h>
#include <string.h>

#define NMAX 16
double prob[NMAX + 1][1 << NMAX], pr, ans;
int N, P, A, B, i, conf;

int main() {
	//freopen("x.txt", "r", stdin);
	int T;
	scanf("%d", &T);
	
	while (T--) {
		scanf("%d", &N);
		if (N <= NMAX) {
			memset(prob[0], 0, sizeof(prob[0]));
			prob[0][0] = 1.0;
		}

		for (i = 1; i <= N; i++) {
			scanf("%d %d %d", &P, &A, &B);
			A--; B--;
			pr = 0.01 * P;
			if (N > NMAX)
				continue;
			for (conf = 0; conf < 65536; conf++) {
				prob[i][conf] = 0.0;
				if ((conf & (1 << A)) > 0)
					prob[i][conf] += prob[i - 1][conf ^ (1 << A)] * pr;
				if ((conf & (1 << B)) > 0)
					prob[i][conf] += prob[i - 1][conf ^ (1 << B)] * (1.0 - pr);
			}
		}
	
		if (N > NMAX)
			printf("0.0\n");
		else {
			ans = 0.0;
			for (conf = 0; conf < 65536; conf++) {
				for (A = B = 0; A < 16; A++)
					if ((conf & (1 << A)) > 0)
						B++;
				if (B == N)
					ans += prob[N][conf];
			}
			printf("%.9lf\n", ans);
		}
	}

	return 0;
}
