#include <stdio.h>

#define MOD 1000000007

#define DMAX 15
int d[DMAX], nd;

long long nmin[DMAX] = {0, 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000};
long long nmax[DMAX] = {0, 9, 99, 999, 9999, 99999, 999999, 9999999, 99999999, 999999999, 9999999999LL};

long long Count(int X) {
	int Xinit = X;

	nd = 0;
	while (X > 0) {
		nd++;
		d[nd] = X % 10;
		X /= 10;
	}

	long long answer = 0, tmp1, tmp2, vmin, vmax;
	int i;
	for (i = 1; i < nd; i++) {
		tmp1 = (nmax[i] * (nmax[i] + 1) / 2) % MOD;
		tmp2 = ((nmin[i] - 1) * nmin[i] / 2) % MOD;
		tmp1 = (tmp1 - tmp2 + MOD) % MOD;
		answer = (answer + tmp1 * i) % MOD;
	}

	//fprintf(stderr, "Count1(%d)=%lld (nd=%d)\n", Xinit, answer, nd);

	vmin = nmin[nd];
	vmax = 0;
	for (i = nd; i >= 1; i--) {
		vmax = vmax + nmin[i] * d[i];
		tmp1 = ((vmax * (vmax + 1)) / 2) % MOD;
		tmp2 = (((vmin - 1) * vmin) / 2) % MOD;
		tmp1 = (tmp1 - tmp2 + MOD) % MOD;
		answer = (answer + tmp1 * nd) % MOD;
		//fprintf(stderr, "%lld-%lld i=%d: %d curans=%lld range=%lld tmp1=%lld\n", vmin, vmax, i, d[i], answer, vmax - vmin + 1, tmp1);
		vmin = vmax + 1;
	}
	
	//fprintf(stderr, "Count(%d)=%lld (nd=%d)\n", Xinit, answer, nd);
	return answer;
}

int main() {
	int T, L, R;
	scanf("%d", &T);
	while (T--) {
		scanf("%d %d", &L, &R);
		printf("%lld\n", (Count(R) - Count(L - 1) + MOD) % MOD);
	}
	return 0;
}
