#include <stdio.h>
#include <algorithm>

using namespace std;

#define NMAX 200111
#define P 1000000007ULL//19997ULL

unsigned long long hleft[NMAX], hright[NMAX], PPOW[NMAX], h1, h2;
char ch[NMAX];
int cnt[NMAX], scnt[NMAX], pmax[NMAX];
int N, i, li, ls, mid, len;
long long answer;

int main() {
	//freopen("x.txt", "r", stdin);

	PPOW[0] = 1;
	for (i = 1; i < NMAX; i++)
		PPOW[i] = PPOW[i - 1] * P;

	int T;
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &N);
		answer = 0;
		scnt[0] = 0;
		for (i = 1; i <= N; i++) {
			scanf(" %c %d", &(ch[i]), &(cnt[i]));
			scnt[i] = scnt[i - 1] + cnt[i];
			answer += (long long) (cnt[i]) * (long long) (cnt[i] + 1) / 2;
		}

		hleft[0] = 0;
		for (i = 1; i <= N; i++) {
			hleft[i] = hleft[i - 1] * P + ch[i];
			hleft[i] = hleft[i] * P + cnt[i];
			//fprintf(stderr, " left %d: %c %d %llu %llu\n", i, ch[i], cnt[i], hleft[i] - hleft[i - 1], ch[i] * P + cnt[i]);
		}
	
		hright[N + 1] = 0;
		for (i = N; i >= 1; i--) {
			hright[i] = hright[i + 1] * P + ch[i];
			hright[i] = hright[i] * P + cnt[i];
			//fprintf(stderr, " right %d: %c %d %llu\n", i, ch[i], cnt[i], hright[i] - hright[i + 1]);
		}

		for (i = 1; i <= N; i++) {
			pmax[i] = 0;
			li = 1; ls = N;
			while (li <= ls) {
				mid = (li + ls) >> 1;
				if (i - mid + 1 <= 0 || i + mid - 1 > N)
					ls = mid - 1;
				else {
					h1 = hleft[i + mid - 1] - hleft[i - mid] * PPOW[4 * mid - 2];
					h2 = hright[i - mid + 1] - hright[i + mid] * PPOW[4 * mid - 2];
					//fprintf(stderr, "  i=%d mid=%d h1=%llu h2=%llu\n", i, mid, h1, h2);
					if (h1 == h2) {
						pmax[i] = mid;
						li = mid + 1;
					} else
						ls = mid - 1;
				}
			}

			//fprintf(stderr, "i=%d: pmax=%d\n", i, pmax[i]);
			len = scnt[i + pmax[i] - 1] - scnt[i - pmax[i]];
			if (i - pmax[i] >= 1 && i + pmax[i] <= N &&
				ch[i - pmax[i]] == ch[i + pmax[i]])
				len += 2 * min(cnt[i - pmax[i]], cnt[i + pmax[i]]);
			answer += ((len - cnt[i]) / 2);
		}
	
		printf("%lld\n", answer);
	}
	
	return 0;
}
