#include <stdio.h>
#include <math.h>

#define NMAX 30
#define eps 1e-6

int x[NMAX], y[NMAX];
int N, i, j, k, p, total, cnt, a1, b1, c1, a2, b2, c2;
double xc, yc, R, D, aa1, bb1, cc1, aa2, bb2, cc2;

int main() {
	int T;

	//freopen("x.txt", "r", stdin);
	scanf("%d", &T);
	
	while (T--) {
		scanf("%d", &N);
		for (i = 0; i < N; i++)
			scanf("%d %d", &x[i], &y[i]);

		cnt = total = 0;
		for (i = 0; i < N; i++)
			for (j = i + 1; j < N; j++)
				for (k = j + 1; k < N; k++) {
					total += (N - 3);

					a1 = y[i] - y[j];
					b1 = x[j] - x[i];
					c1 = x[i] * y[j] - x[j] * y[i];

					c2 = a1 * x[k] + b1 * y[k] + c1;
					if (c2 == 0)
						continue;

					a2 = y[j] - y[k];
					b2 = x[k] - x[j];
					c2 = x[j] * y[k] - x[k] * y[j];
					
					xc = 0.5 * (x[i] + x[j]);
					yc = 0.5 * (y[i] + y[j]);
					aa1 = -b1;
					bb1 = a1;
					cc1 = -aa1 * xc - bb1 * yc;

					xc = 0.5 * (x[k] + x[j]);
					yc = 0.5 * (y[k] + y[j]);
					aa2 = -b2;
					bb2 = a2;
					cc2 = -aa2 * xc - bb2 * yc;
					
					//fprintf(stderr, "  %d %d: %lf %lf %lf\n", a1, b1, aa1, bb1, cc1);
					//fprintf(stderr, "    %d %d: %lf %lf %lf\n", a2, b2, aa2, bb2, cc2);
					
					xc = (double) (bb2 * cc1 - bb1 * cc2) / (double) (aa2 * bb1 - aa1 * bb2);
					yc = (double) (cc2 * aa1 - cc1 * aa2) / (double) (aa2 * bb1 - aa1 * bb2);

					R = (x[i] - xc) * (x[i] - xc) + (y[i] - yc) * (y[i] - yc);
					
					for (p = 0; p < N; p++)
						if (p != i && p != j && p != k) {
							D = (x[p] - xc) * (x[p] - xc) + (y[p] - yc) * (y[p] - yc);
							if (D < R || fabs(D - R) < eps) {
								cnt++;
								//fprintf(stderr, "  (%d,%d) (%d,%d) (%d,%d): (%lf,%lf) %lf: %lf (%d,%d)\n", x[i], y[i], x[j], y[j], x[k], y[k], xc, yc, R, D, x[p], y[p]);
							}
						}
				}

		//fprintf(stderr, "cnt=%d total=%d\n", cnt, total);
		printf("%.9lf\n", (double) cnt / (double) total);
	}

	return 0;
}
