#include <stdio.h>
#include <string.h>
#include <algorithm>

using namespace std;

#define TMAX 131072

int sum[2 * TMAX], t[2 * TMAX], tidx;

void Update(int poz) {
	poz = TMAX + poz - 1;
	while (poz >= 1) {
		if (t[poz] != tidx) {
			sum[poz] = 0;
			t[poz] = tidx;
		}
		sum[poz]++;
		poz >>= 1;
	}
}

int Query(int poz) {
	int ans = 0;
	poz = TMAX + poz - 1;
	while (poz > 1) {
		if (poz & 1) {
			if (t[poz - 1] != tidx) {
				sum[poz - 1] = 0;
				t[poz - 1] = tidx;
			}
			ans += sum[poz - 1];
		}
		poz >>= 1;
	}
	return ans;
}

#define NMAX 111111

char S[NMAX];
int level[NMAX], clevel[NMAX], stk[NMAX];
long long ans;
int N, niv, i;

int main() {
	//freopen("x.txt", "r", stdin);
	int T;
	scanf("%d", &T);
	while (T--) {
		scanf("%d %s", &N, S + 1);
		niv = 0;
		memset(level, 0, (N + 1) * sizeof(int));
		for (i = 1; i <= N; i++)
			if (S[i] == '4') {
				niv++;
				stk[niv] = i;
				clevel[niv] = 1;
			} else if (niv > 0) {
				level[stk[niv]] = clevel[niv];
				clevel[niv - 1] = max(clevel[niv - 1], clevel[niv] + 1);
				niv--;
			}

		tidx++;
		ans = 0;
		for (i = 1; i <= N; i++)
			if (level[i] > 0) {
				ans += (i - 2 * Query(level[i]));
				//fprintf(stderr, "i=%d: %d ans=%lld\n", i, level[i], ans);
				Update(level[i]);
			}
	
		printf("%lld\n", ans);
	}
	
	return 0;
}
