#include <stdio.h>

#define NMAX 200001
#define INF 1000000000

long long d[NMAX], sd[NMAX], DMAX;
int c[NMAX], dmin[NMAX], L;
int N, i, li, ls, mid, ans;

int Solve(int CMAX) {
	int i, j;

	dmin[0] = 0;
	j = 0;
	
	for (i = 1; i <= N; i++) {
		dmin[i] = INF;
		while (j < i && (sd[i] - sd[j] > DMAX || c[j] > CMAX))
			j++;
		//fprintf(stderr, "CMAX=%d/%d: i=%d (%lld) j=%d (%lld)\n", CMAX, N, i, sd[i], j, sd[j]);
		if (j < i && dmin[j] < INF)
			dmin[i] = dmin[j] + 1;
	}
	
	return dmin[N];
}

int main() {
	int T;
	
	//freopen("x.txt", "r", stdin);
	scanf("%d", &T);
	while (T--) {
		scanf("%d %lld", &N, &DMAX);
		for (i = 1; i <= N; i++)
			scanf("%lld %d", &d[i], &c[i]);

		sd[0] = 0;
		for (i = 1; i <= N; i++)
			sd[i] = sd[i - 1] + d[i];
	
		c[0] = 0;
		L = Solve(N);
		ans = N;

		li = 0; ls = N - 1;
		while (li <= ls) {
			mid = (li + ls) >> 1;
			if (Solve(mid) == L) {
				ans = mid;
				ls = mid - 1;
			} else
				li = mid + 1;
		}

		printf("%d %d\n", L, ans);
	}
	
	return 0;
}
